#include "../include/YAXServer.h"
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

void YAXThrowEvent(int32_t obj, int32_t event, int32_t data1, int32_t data2)
{
   YAXEventList *EL;
   YAXObject *O;
   YAXEvent *E;

   O=GetObject(obj);
   if(O==NULL) return;
   if(EventListHead!=NULL) {
      for(EL=EventListHead;EL->next!=NULL;EL=EL->next);
      (int)(EL->next)=malloc(sizeof(YAXEventList));
      EL=EL->next;
   }
   else {
      (int)EventListHead=malloc(sizeof(YAXEventList));
      EL=EventListHead;
   }
   (int)E=malloc(sizeof(YAXEvent));
   E->fd=O->fd;
   E->x=mouse_x;
   E->y=mouse_y;
   E->buttons=buttons;
   E->shifts=shifts;
   E->type=event;
   E->obj=obj;
   E->data1=data1;
   E->data2=data2;
   EL->next=NULL;
   EL->event=E;
   EL->fd=E->fd;
   write(E->fd, "$", 1);
}

int32_t YAXEventsQueued(int32_t fd)
{
   YAXEventList *L;
   int32_t num=0;

   for(L=EventListHead;L!=NULL;L=L->next)
      if(L->fd==fd) num++;
   YAXReturnInt(fd, num);
}

int32_t YAXGetEvent(int32_t fd)
{
   YAXEventList *L;
   int32_t num, whence=0;

   num=YAXGetInt(fd);
   for(L=EventListHead;L!=NULL;L=L->next) {
      if(L->fd==fd) {
         if(whence==num) {
            YAXReturnInt(fd, 0);
            write(fd, L->event, sizeof(YAXEvent));
            return 0;
         }
         whence++;
      }
   }
   YAXReturnInt(fd, -1);
}

int32_t YAXRemoveEvent(int32_t fd)
{
   YAXEventList *L, *Prev;
   int32_t num, whence=0;

   num=YAXGetInt(fd);
   Prev=NULL;
   for(L=EventListHead;L!=NULL;Prev=L,L=L->next) {
      if(L->fd==fd) {
         if(whence==num) {
            YAXReturnInt(fd, 0);
            if(Prev==NULL) EventListHead=L->next;
            else Prev->next=L->next;
            free(L);
            return 0;
         }
         whence++;
      }
   }
   YAXReturnInt(fd, -1);
}

