/* YAX_globals.c
 *    This file should read the YAXConfig file to determine
 * the settings for the window system, but for now just sets
 * the global variables to some convenient defaults.
 */

#define __YAX_GLOBALS__	1
#include "../include/YAXServer.h"
#include <vga.h>
#include <vgagl.h>

int32_t YAX_Mode;
int32_t YAX_Width;
int32_t YAX_Height;
int32_t YAX_Colours;
int32_t ObjectNextNum;
int32_t ActiveObject, CurrentlyApparent;
int32_t mouse_x, mouse_y, buttons, shifts;
GraphicsContext YAX_VGA, YAX_gc;
struct YAXFuncStruct YAX[MAXFUNCS];
YAXEventList *EventListHead;
YAXObjectList *ObjectListHead;
YAXMessageList *MessageListHead;
YAXOverlapList *HeadOverlapList;
unsigned char *MousePtr[5], *MouseOverPtr;
int32_t CurrentMouse, MouseOldObj, MouseOldButtons, MouseHidden;

unsigned char MouseArrow[16][16] = {
   { 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 7, 7, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

unsigned char MouseWatch[16][16] = {
   { 0, 0, 0, 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 7, 8, 7, 7, 7, 8, 7, 0, 0, 0, 0 },
   { 0, 7, 8, 7, 7, 7, 8, 7, 7, 7, 7, 8, 7, 0, 0, 0 },
   { 7, 7, 8, 7, 7, 7, 8, 7, 7, 7, 7, 8, 7, 0, 0, 0 },
   { 7, 7, 8, 7, 7, 7, 8, 7, 7, 7, 7, 8, 7, 0, 0, 0 },
   { 7, 7, 8, 7, 7, 7, 7, 8, 8, 8, 7, 8, 7, 0, 0, 0 },
   { 0, 7, 8, 7, 7, 7, 7, 7, 7, 7, 7, 8, 7, 0, 0, 0 },
   { 0, 7, 8, 7, 7, 7, 7, 7, 7, 7, 7, 8, 7, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 7, 7, 7, 7, 7, 8, 7, 0, 0, 0, 0 },
   { 0, 0, 0, 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 7, 8, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

unsigned char MouseText[16][16] = {
   { 7, 7, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 7, 8, 8, 8, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 7, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 7, 8, 8, 8, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 8, 8, 8, 8, 8, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 7, 7, 7, 7, 7, 7, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

unsigned char MouseHand[16][16] = {
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
   { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
};

void YAX_setglobals()
{
   YAX_Mode=G800x600x256;
   YAX_Width=800;
   YAX_Height=600;
   YAX_Colours=256;
   printf(" * Mode: %d (%dx%dx%d)\n", YAX_Mode, YAX_Width, YAX_Height, YAX_Colours);
   MousePtr[YAXMouseArrow]=&MouseArrow[0][0];
   MousePtr[YAXMouseWatch]=&MouseWatch[0][0];
   MousePtr[YAXMouseText]=&MouseText[0][0];
   MousePtr[YAXMouseHand]=&MouseHand[0][0];
   MousePtr[YAXMouseDefinable]=&MouseArrow[0][0];
}

