#include "../include/YAXServer.h"
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

int32_t UpdateOnScreen(YAXObject *O)
{
   YAXOverlapList *LL;
   YAXOverlapList *InvertListHead, *IL;
   char *p;

   gl_setcontext(&YAX_gc);
   gl_setclippingwindow(O->realx, O->realy, O->realx+O->width, O->realy+O->height);
   (int)IL=malloc(sizeof(YAXOverlapList));
   InvertListHead=NULL;
   for(LL=HeadOverlapList;LL!=NULL;LL=LL->next) {
      memcpy(IL, LL, sizeof(YAXOverlapList));
      IL->next=InvertListHead;
      InvertListHead=IL;
      if(IL->object==O) break;
      (int)IL=malloc(sizeof(YAXOverlapList));
   }
   for(LL=InvertListHead;LL!=NULL; LL=LL->next) {
      if((LL->x1<=O->realx && LL->x2>=O->realx) || \
       (LL->x1<=O->realx+O->width && LL->x2>=O->realx+O->width) || \
       (LL->y1<=O->realy && LL->y2>=O->realy) || \
       (LL->y1<=O->realy+O->height && LL->y2>=O->realy+O->height) \
      ) {
         gl_putbox(LL->object->realx, LL->object->realy, LL->object->width, LL->object->height, LL->object->look);
      }
   }
   LL=InvertListHead;
   while(LL!=NULL) {
      InvertListHead=LL->next;
      free(LL);
      LL=InvertListHead;
   }
   (int)p=malloc(O->width*O->height);
   gl_setclippingwindow(0, 0, YAX_Width, YAX_Height);
   gl_getbox(O->realx, O->realy, O->width, O->height, p);
   gl_setcontextvga(YAX_Mode);
   hideMouse();
   gl_putbox(O->realx, O->realy, O->width, O->height, p);
   refreshMouse();
   showMouse();
   free(p);
}

int32_t YAXSetColourCell(int32_t fd)
{
   int32_t cell, r, g, b;

   cell=YAXGetInt(fd);
   r=YAXGetInt(fd);
   g=YAXGetInt(fd);
   b=YAXGetInt(b);
   gl_setpalettecolor(cell, r, g, b);
   YAXReturnInt(fd, 0);
}

int32_t YAXGetColourCell(int32_t fd)
{
   int32_t cell, r, g, b;

   cell=YAXGetInt(fd);
   gl_getpalettecolor(cell, &r, &g, &b);
   YAXReturnInt(fd, r);
   YAXReturnInt(fd, g);
   YAXReturnInt(fd, b);
}

int32_t YAXPutImage(int32_t fd)
{
   int32_t obj, x, y, w, h;
   char *buf;
   YAXObject *O;

   obj=YAXGetInt(fd);
   x=YAXGetInt(fd);
   y=YAXGetInt(fd);
   w=YAXGetInt(fd);
   h=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   (int)buf=malloc(w*h);
   read(fd, buf, w*h);
   gl_setcontext(&YAX_gc);
   gl_putbox(0, 0, O->width, O->height, O->look);
   gl_putbox(x, y, w, h, buf);
   gl_getbox(0, 0, O->width, O->height, O->look);
   gl_setcontext(&YAX_VGA);
   UpdateOnScreen(O);
   free(buf);
}

int32_t YAXGetImage(int32_t fd)
{
   int32_t obj, x, y, w, h;
   char *buf;
   YAXObject *O;

   obj=YAXGetInt(fd);
   x=YAXGetInt(fd);
   y=YAXGetInt(fd);
   w=YAXGetInt(fd);
   h=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   (int)buf=malloc(w*h);
   gl_setcontext(&YAX_gc);
   gl_putbox(0, 0, O->width, O->height, O->look);
   gl_getbox(x, y, w, h, buf);
   gl_setcontext(&YAX_VGA);
   write(fd, buf, w*h);
   free(buf);
}

int32_t YAXFill(int32_t fd)
{
   int32_t obj, x1, y1, x2, y2, c;
   YAXObject *O;

   obj=YAXGetInt(fd);
   x1=YAXGetInt(fd);
   y1=YAXGetInt(fd);
   x2=YAXGetInt(fd);
   y2=YAXGetInt(fd);
   c=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   gl_setcontext(&YAX_gc);
   gl_putbox(0, 0, O->width, O->height, O->look);
   gl_fillbox(x1, y1, x2-x1, y2-y1, c);
   gl_getbox(0, 0, O->width, O->height, O->look);
   gl_setcontext(&YAX_VGA);
   UpdateOnScreen(O);
   YAXReturnInt(fd, 0);
}

int32_t YAXDrawLine(int32_t fd)
{
   int32_t obj, x1, y1, x2, y2, c;
   YAXObject *O;

   obj=YAXGetInt(fd);
   x1=YAXGetInt(fd);
   y1=YAXGetInt(fd);
   x2=YAXGetInt(fd);
   y2=YAXGetInt(fd);
   c=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   gl_setcontext(&YAX_gc);
   gl_putbox(0, 0, O->width, O->height, O->look);
   gl_line(x1, y1, x2, y2, c);
   gl_getbox(0, 0, O->width, O->height, O->look);
   gl_setcontext(&YAX_VGA);
   UpdateOnScreen(O);
   YAXReturnInt(fd, 0);
}

int32_t YAXSetPixel(int32_t fd)
{
   int32_t obj, x, y, c;
   YAXObject *O;

   obj=YAXGetInt(fd);
   x=YAXGetInt(fd);
   y=YAXGetInt(fd);
   c=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   gl_setcontext(&YAX_gc);
   gl_putbox(0, 0, O->width, O->height, O->look);
   gl_setpixel(x, y, c);
   gl_getbox(0, 0, O->width, O->height, O->look);
   gl_setcontext(&YAX_VGA);
   UpdateOnScreen(O);
   YAXReturnInt(fd, 0);
}

int32_t YAXGetPixel(int32_t fd)
{
   int32_t obj, x, y, pix;
   YAXObject *O;

   obj=YAXGetInt(fd);
   x=YAXGetInt(fd);
   y=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   gl_setcontext(&YAX_gc);
   gl_putbox(0, 0, O->width, O->height, O->look);
   pix=gl_getpixel(x, y);
   gl_setcontext(&YAX_VGA);
   YAXReturnInt(fd, pix);
}

int32_t YAXSetPalette(int32_t fd)
{
   int32_t obj;
   YAXObject *O;

   obj=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   read(fd, O->palette, sizeof(int)*256);
   if(CurrentlyApparent==obj) gl_setpalette(O->palette);
}

int32_t YAXGetPalette(int32_t fd)
{
   int32_t obj;
   YAXObject *O;

   obj=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   write(fd, O->palette, sizeof(int)*256);
}

