#include "../include/YAXServer.h"
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

int32_t YAXSendMessage(int32_t fd)
{
   YAXMessageList *L;
   YAXMessage *M;
   YAXObject *OTo, *OFrom;
   int32_t to, from, len;

   (int)M=malloc(sizeof(YAXMessage));
   from=YAXGetInt(fd);
   to=YAXGetInt(fd);
   len=YAXGetInt(fd);
   OTo=GetObject(to);
   OFrom=GetObject(from);
   if(OTo==NULL || OFrom==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   M->to=OTo;
   M->from=OFrom;
   M->len=len;
   read(fd, M->data, len);
   if(MessageListHead!=NULL) {
      for(L=MessageListHead;L->next!=NULL;L=L->next);
      (int)(L->next)=malloc(sizeof(YAXMessageList));
      L=L->next;
   }
   else {
      (int)MessageListHead=malloc(sizeof(YAXMessageList));
      L=MessageListHead;
   }
   L->fd=OTo->fd;
   L->message=M;
   L->next=NULL;
   YAXThrowEvent(OTo->num, YAXMessageReceivedEvent, 0, 0);
}

int32_t YAXMessagesQueued(int32_t fd)
{
   YAXMessageList *L;
   int32_t num=0;

   for(L=MessageListHead;L!=NULL;L=L->next)
      if(L->fd==fd) num++;
   YAXReturnInt(fd, num);
}

int32_t YAXGetMessage(int32_t fd)
{
   YAXMessageList *L;
   int32_t num, whence=0;

   num=YAXGetInt(fd);
   for(L=MessageListHead;L!=NULL;L=L->next) {
      if(L->fd==fd) {
         if(whence==num) {
            YAXReturnInt(fd, 0);
            write(fd, L->message, sizeof(YAXMessage));
            return 0;
         }
         whence++;
      }
   }
   YAXReturnInt(fd, -1);
}

int32_t YAXRemoveMessage(int32_t fd)
{
   YAXMessageList *L, *Prev;
   int32_t num, whence=0;

   num=YAXGetInt(fd);
   for(L=MessageListHead;L!=NULL;Prev=L,L=L->next) {
      if(L->fd==fd) {
         if(whence==num) {
            YAXReturnInt(fd, 0);
            Prev->next=L->next;
            free(L);
            return 0;
         }
         whence++;
      }
   }
   YAXReturnInt(fd, -1);
}

