#include "../include/YAXServer.h"
#include <vgamouse.h>
#include <vgagl.h>

void showMouse()
{
   MouseHidden=0;
   gl_putboxmask(mouse_x, mouse_y, 16, 16, MousePtr[CurrentMouse]);
}

void hideMouse()
{
   MouseHidden=1;
   gl_putbox(mouse_x, mouse_y, 16, 16, MouseOverPtr);
}

void refreshMouse()
{
   gl_getbox(mouse_x, mouse_y, 16, 16, MouseOverPtr);
}

int32_t YAXSetDefinableCursor(int32_t fd)
{
   YAXObject *O;

   O=GetObject(YAXGetInt(fd));
   if(O==NULL) {
      YAXReturnInt(fd, 0);
      return 0;
   }
   read(fd, O->DefinableMouse, 32*32);
}

void YAXMouseHandler(int32_t button, int32_t dx, int32_t dy, int32_t dz, int32_t drx, int32_t dry, int32_t drz)
{
   YAXOverlapList *LL;
   YAXObject *O, *PO;
   int32_t i;

   if(MouseHidden) return;
   hideMouse();
   mouse_x+=dx;
   mouse_y+=dy;
   buttons=button;
   if(mouse_x>YAX_Width) mouse_x=YAX_Width;
   if(mouse_y>YAX_Height) mouse_y=YAX_Height;
   if(mouse_y<0) mouse_y=0;
   if(mouse_x<0) mouse_x=0;
   mouse_setposition(mouse_x, mouse_y);
   gl_getbox(mouse_x, mouse_y, 16, 16, MouseOverPtr);
   showMouse();
   for(LL=HeadOverlapList;LL!=NULL;LL=LL->next)
      if(mouse_x>=LL->x1 && mouse_x<=LL->x2 && mouse_y>=LL->y1 && mouse_y<=LL->y2) break;
   if(LL==NULL) return;
/*   printf("%d ", LL->object->num); */
   O=LL->object;
   if((O->event_mask & YAXPointerMotionEvent)==0)
      YAXThrowEvent(O->num, YAXPointerMotionEvent, dx, dy);
   if(buttons!=MouseOldButtons) {
      for(i=1;i<8;i=i<<1) {
         if((MouseOldButtons & i)!=0 && (buttons & i)==0) {
            if((O->event_mask & YAXButtonReleaseEvent)==0)
               YAXThrowEvent(O->num, YAXButtonReleaseEvent, 0, 0);
         }         
         if((MouseOldButtons & i)==0 && (buttons & i)!=0) {
            if((O->event_mask & YAXButtonPressEvent)==0)
               YAXThrowEvent(O->num, YAXButtonPressEvent, 0, 0);
         }
      }
      MouseOldButtons=buttons;
   }
   if(O->num!=MouseOldObj) {
      PO=GetObject(MouseOldObj);
      if(PO!=NULL) {
         if((PO->event_mask & YAXPointerExitEvent)==0)
            YAXThrowEvent(PO->num, YAXPointerExitEvent, 0, 0);
      }
      if((O->event_mask & YAXPointerEnterEvent)==0)
         YAXThrowEvent(O->num, YAXPointerEnterEvent, 0, 0);
      MouseOldObj=O->num;
      CurrentMouse=O->mouse;
      MousePtr[4]=O->DefinableMouse;
   }
}

