#include "../include/YAXServer.h"
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>

int32_t YAXCreateObject(int32_t fd)
{
   YAXObjectList *OL;
   YAXObject *O, *P;
   int32_t par;

   par=YAXGetInt(fd);
   P=GetObject(par);
   if(P==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   P->isAParent=1;
   (int)O=malloc(sizeof(YAXObject));
   if(ObjectListHead!=NULL) {
      for(OL=ObjectListHead;OL->next!=NULL;OL=OL->next);
      (int)(OL->next)=malloc(sizeof(YAXObjectList));
      OL=OL->next;
   }
   else {
      (int)ObjectListHead=malloc(sizeof(YAXObjectList));
      OL=ObjectListHead;
   }
   OL->next=NULL;
   OL->object=O;
   OL->fd=fd;
   OL->num=ObjectNextNum;
   O->x=0;
   O->y=0;
   O->realx=P->x;
   O->realy=P->y;
   O->parent=par;
   O->num=OL->num;
   O->width=0;
   O->height=0;
   O->active=0;
   O->fd=fd;
   O->event_mask=0;
   O->look=NULL;
   O->invisible=0;
   O->mouse=0;
   (int)(O->DefinableMouse)=malloc(32*32);
   O->isAParent=0;
   memcpy(O->palette, P->palette, sizeof(int)*256);
   YAXReturnInt(fd, ObjectNextNum);
   ObjectNextNum++;
   PlaceOnTop(O);
}

int32_t YAXSetActiveObject(int32_t fd)
{
   ActiveObject=YAXGetInt(fd);
   /* Make the changes on-screen */
   YAXReturnInt(fd, 0);
}

int32_t YAXGetActiveObject(int32_t fd)
{
   YAXReturnInt(fd, ActiveObject);
}

int32_t YAXGetObjectAttr(int32_t fd)
{
   YAXObject *O;
   YAXObjectAttr *At;
   int32_t obj;

   obj=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   (int)At=malloc(sizeof(YAXObjectAttr));
   At->parent=O->parent;
   At->num=O->num;
   At->x=O->x;
   At->y=O->y;
   At->width=O->width;
   At->height=O->height;
   At->active=O->active;
   At->event_mask=O->event_mask;
   At->mouse=O->mouse;
   YAXReturnInt(fd, 0);
   write(fd, At, sizeof(YAXObjectAttr));
   free(At);
}

int32_t YAXSetObjectAttr(int32_t fd)
{
   YAXObject *O, *P;
   YAXObjectAttr *NewO;
   int32_t obj;

   obj=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   P=GetObject(O->parent);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   (int)NewO=malloc(sizeof(YAXObjectAttr));
   read(fd, NewO, sizeof(YAXObjectAttr));
   if(O->width!=NewO->width || O->height!=NewO->height) {
      O->width=NewO->width+1;
      if(O->width>P->width) O->width=P->width;
      O->height=NewO->height+1;
      if(O->height>P->height) O->height=P->height;
      if(O->look!=NULL) free(O->look);
      (int)(O->look)=malloc((O->width)*(O->height));
      hideMouse();
      gl_getbox(O->realx, O->realy, O->width, O->height, O->look);
      showMouse();
      PlaceOnTop(O);
      CurrentlyApparent=O->num;
   }
   if(O->x!=NewO->x || O->y!=NewO->y) {
      EraseObject(O);
      AdjustObjectCoord(O, P, NewO->x, NewO->y);
      PlaceOnTop(O);
      CurrentlyApparent=O->num;
   }
   if(O->mouse!=NewO->mouse & NewO->mouse<5) {
      if(MouseOldObj==O->num) CurrentMouse=NewO->mouse;
      O->mouse=NewO->mouse;
   }
   O->event_mask=NewO->event_mask;
   YAXReturnInt(fd, 0);
}

int32_t YAXDestroyObject(int32_t fd)
{
   YAXObject *O;
   int32_t obj;

   obj=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   DoDestroy(O);
   YAXReturnInt(fd, 0);
}

int32_t DoDestroy(YAXObject *O)
{
   YAXObjectList *OL, *OP;
   YAXOverlapList *LL, *LP;

   OP=NULL;
   for(OL=ObjectListHead;OL!=NULL;OL=OL->next) {
      if(OL->object->num==O->num) break;
      OP=OL;
   }
   if(OL==NULL) return 0;
   if(OP==NULL) ObjectListHead=OL->next;
   else OP->next=OL->next;
   free(OL);
   LP=NULL;
   for(LL=HeadOverlapList;LL!=NULL;LL=LL->next) {
      if(LL->object==O) break;
      LP=LL;
   }
   if(LP==NULL) HeadOverlapList=LL->next;
   else LP->next=LL->next;
   free(LL);
   if(O->num==ActiveObject) ActiveObject=O->parent;
   EraseObject(O);
   for(OL=ObjectListHead;OL!=NULL;OL=OL->next)
      if(OL->object->parent==O->num) DoDestroy(OL->object);
   free(O->DefinableMouse);
   free(O);
}

int32_t YAXMakeApparent(int32_t fd)
{
   YAXObject *O;
   int32_t obj;

   obj=YAXGetInt(fd);
   O=GetObject(obj);
   if(O==NULL) {
      YAXReturnInt(fd, -1);
      return 0;
   }
   YAXReturnInt(fd, 0);
   AdjustObjectCoord(O, GetObject(O->parent), O->x, O->y);
   PlaceOnTop(O);
   CurrentlyApparent=obj;
   gl_setpalette(O->palette);
}

