#include "../include/YAXServer.h"
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <vgamouse.h>
#include <vgakeyboard.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <signal.h>

void YAXMouseHandler(int32_t button, int32_t dx, int32_t dy, int32_t dz, int32_t drx, int32_t dry, int32_t drz);
int32_t mainsock, conarray[25], mouse_fd;
fd_set conns, holder;

void YAXExitHandler(int32_t n)
{
   close(mainsock);
   mouse_close();
/*   vga_setmode(TEXT); */
   printf(" * YAX Terminating normally\n");
   exit(0);
}

main(int32_t argc, char *argv[])
{
   int32_t nums, len, newsock, i, j, ln, nm, res, keyb_fd;
   char instr[10], ch;
   struct sockaddr_un sin;
   struct timeval tv;
   YAXObject *OOO;

   printf(" * YAX Standard Server, v%d.%d.%d (%s), Compiled %s\n", SSVER_MAJ, SSERV_MIN, SSERV_PL, SSERV_STRING, __DATE__);
   unlink("/tmp/YAX.sock");
   if(argc<2) {
      printf(" - Required: primary child argument\n");
      exit(-1);
   }
   YAX_setglobals();
   mainsock=socket(AF_UNIX, SOCK_STREAM, 0);
   sin.sun_family=AF_UNIX;
   strcpy(sin.sun_path, "/tmp/YAX.sock");
   bind(mainsock, (struct sockaddr *)&sin, sizeof(struct sockaddr));
   listen(mainsock, 5);
   if((res=fork())) {
      printf("[%d]\n", res);
      exit(0);
   }
   if((res=fork())==0) {
      sleep(1);	/* Kludgy, kludgy... */
      execvp(argv[1], &argv[1]);
      exit(-1);
   }
   printf("[%d]\n", res);
   signal(SIGCHLD, YAXExitHandler);
   if(vga_init()) {
      printf("vga_init(): Unable to initialize VGA driver...\nShutting down\n");
      exit(-1);
   }
   if(!vga_hasmode(YAX_Mode)) {
      printf("main(): Mode %dx%dx%d not supported by hardware...\nShutting down\n", YAX_Width, YAX_Height, YAX_Colours);
      exit(-1);
   }
   vga_setmode(YAX_Mode);
   gl_setcontextvgavirtual(YAX_Mode);
   gl_getcontext(&YAX_gc);
   gl_setcontextvga(YAX_Mode);
   gl_getcontext(&YAX_VGA);
   gl_enableclipping();
   gl_setclippingwindow(0, 0, YAX_Width, YAX_Height);
   mouse_fd=mouse_init_return_fd("/dev/mouse", vga_getmousetype(), 100);
   if(mouse_fd==-1) {
      perror("mouse_init()");
      vga_setmode(TEXT);
      exit(-1);
   }
   keyb_fd=keyboard_init_return_fd();
   mouse_setposition(200, 200);
   mouse_x=200;
   mouse_y=200;
   MouseOldObj=0;
   MouseOldButtons=0;
   MouseHidden=0;
   CurrentMouse=0;
   (int)MouseOverPtr=malloc(16*16);
   gl_getbox(mouse_x, mouse_y, 16, 16, MouseOverPtr);
   YAX_InitFuncStruct();
   FD_ZERO(&conns);
   FD_SET(mainsock, &conns);
   FD_SET(mouse_fd, &conns);
   FD_SET(keyb_fd, &conns);
   holder=conns;
   (int)ObjectListHead=malloc(sizeof(YAXObjectList));
   ObjectListHead->fd=0;
   ObjectListHead->num=0;
   ObjectListHead->next=NULL;
   (int)OOO=malloc(sizeof(YAXObject));
   ObjectListHead->object=OOO;
   OOO->parent=0;
   OOO->num=0;
   OOO->x=0;
   OOO->y=0;
   OOO->realx=0;
   OOO->realy=0;
   OOO->width=YAX_Width;
   OOO->height=YAX_Height;
   OOO->active=1;
   OOO->fd=0;
   OOO->event_mask=0xFFFF;
   OOO->mouse=0;
   OOO->DefinableMouse=MousePtr[0];
   OOO->invisible=0;
   gl_getpalette(OOO->palette);
   (int)(OOO->look)=malloc(YAX_Width * YAX_Height);
   gl_getbox(0, 0, YAX_Width, YAX_Height, OOO->look);
   ObjectNextNum=1;
   (int)HeadOverlapList=malloc(sizeof(YAXOverlapList));
   HeadOverlapList->object=OOO;
   HeadOverlapList->x1=0;
   HeadOverlapList->y1=0;
   HeadOverlapList->x2=YAX_Width;
   HeadOverlapList->y2=YAX_Height;
   HeadOverlapList->next=NULL;
   mouse_seteventhandler(YAXMouseHandler);
   keyboard_seteventhandler(KeyboardEventHandler);
   showMouse();
   while(1) {
      conns=holder;
      tv.tv_sec=0;
      tv.tv_usec=0;
      nums=select(FD_SETSIZE, &conns, NULL, NULL, NULL);
      if(FD_ISSET(mainsock, &conns)) {
         printf("Action!\n");
         newsock=accept(mainsock, (struct sockaddr *)&sin, &len);
         FD_SET(newsock, &holder);
         FD_SET(mainsock, &holder);
         for(i=0;i<25;i++) {
            if(conarray[i]==0) {
               conarray[i]=newsock;
               break;
            }
         }
      }
      else if(FD_ISSET(mouse_fd, &conns)) mouse_update();
      else if(FD_ISSET(keyb_fd, &conns)) keyboard_update();
      else {
         for(i=0;i<25;i++) {
            if(FD_ISSET(conarray[i], &conns)) {
               bzero(instr, 10);
               ch=0;
               ln=j=0;
               while(ch!=' ') {
                  ln=read(conarray[i], &ch, 1);
                  if(ln==1 && ch>=48 && ch<=57) {
                     instr[j]=ch;
                     j++;
                  }
               }
               nm=atoi(instr);
               if(nm==YAXCLOSEDISPLAY) FD_CLR(conarray[i], &holder);
               YAX_interp(nm, conarray[i]);
            }
         }
      }
   }
   printf("main(): Whoa! This shouldn't be happening!\n");
   vga_setmode(TEXT);
   exit(-2);
}

void YAX_interp(int32_t instr, int32_t fd)
{
   if(instr>MAXFUNCS) printf("YAX_interp(): Received bad request from client %d\n", fd);
   else if(YAX[instr].func!=NULL) YAX[instr].func(fd);
}

