#!/bin/sh

echo "YAX Standard Services Installer"
echo "   This program will install the Standard set of services for"
echo "the YAX API. To install this distribution you must first have"
echo "installed the Base distribution."
if [ -e /usr/lib/YAX ];
 then echo "+ Base distribution detected";
 else echo "- Base distribution not found"; exit;
fi
cd Server
if make;
 then echo "+ Standard Server made successfully";
 else echo "- Standard Server make unsuccessful"; exit;
fi
cd ../YAXlib
if make;
 then echo "+ Standard YAXlib made successfully";
 else echo "- Standard YAXlib make unsuccessful"; exit;
fi
cd ..
cp -f Server/YAX /usr/bin
cp -f YAXlib/libYAX.so /usr/lib
if [ -e /usr/doc/YAX/Standard ];
 then echo "* Standard directory already created";
 else echo "Creating standard directory..."; mkdir /usr/doc/YAX/Standard;
fi
cp -f doc/* /usr/doc/YAX/Standard
echo "   Standard YAX Services installed. You may now remove this"
echo "directory and its files."

